/*
                                 Visual FX
                                    For
                                 Image FX
                               SetUp Script
                           Written By J.L. White

                         (C)1997 Merlin's Software

*/

parse arg Num Frames
options results
address "IMAGEFX.1"
ReDraw On

	RequestResponse "Do You Need Instructions?"
	if rc = 0 then do
		call Docs()
		end
	
if exists("libs:flyer.library") then do
	if (POS('PROJECT_REXX_PORT',SHOW('Ports')) =0) then do
		RequestNotify 'Flyer Must Be Running First!'
		exit
		end
	call OpenFlyStuff()


	Gadget.1 = 'D/110/22/120/ImageA Type/4/FLYER CLIP/FLYER STILL/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1
   		end

	call GetA()
end
else do
	Gadget.1 = 'D/110/22/120/ImageA Type/2/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1+2
   		end

	call GetA()
end

if FlyOn = 1 then
	call CloseStuff()

	Gadget.1 = 'Select Operator To Use!'
	Gadget.2 = 'Grey Scale'
	Gadget.3 = 'Emboss'
	Gadget.4 = 'Antique'
	Gadget.5 = 'Solarize'
	Gadget.6 = 'Negative'
	Gadget.7 = 'Posterize'
	Gadget.8 = 'False Color'
	Gadget.9 = 'Lighten'
	Gadget.10 = 'Darken'
	Gadget.11 = 'SobelEdge'
	ListRequest 11 Gadget
	Type2 = 0
	if result = 2 then Type2 = 0
	if result = 3 then Type2 = 1
	if result = 4 then Type2 = 2
	if result = 5 then Type2 = 3
	if result = 6 then Type2 = 4
	if result = 7 then Type2 = 5
	if result = 8 then Type2 = 6
	if result = 9 then Type2 = 7
	if result = 10 then Type2 = 8
	if result = 11 then Type2 = 9

	NumA = 0
	NumB = 100
	NumC = 50
	RequestSlider '"Enter Amount To Feather Edges!"' NumA NumB NumC
	Feather = Result

	Gadget.1 = 'Select Picture Options!'
	Gadget.2 = 'Use Standard Size'
	Gadget.3 = 'User Defined Size'
	ListRequest 3 Gadget
	WindowType = -1
	if result = 2 then WindowType = -1
	if result = 3 then do
		i = Start
		call LoadA()
		call PickCircle()
		end


call open TempFile,"VFXIFX:TempDrawer/"strip(Num),W
call writeln TempFile,PicAName
call writeln TempFile,Start
call writeln TempFile,End
call writeln TempFile,IAType
call writeln TempFile,Type2
call writeln TempFile,Feather
call writeln TempFile,WindowType
call close TempFile
exit



Docs:

	text1 = '"This effect takes an image and applies an operator"'
	text2 = '"around the edges of an oval shape. The shape can"'
	text3 = '"be user defined with Feathered edges. The larger"'
	text4 = '"the number for the Feather the longer it takes to"'
	text5 = '"render, but the results are worth it. "'

	Gadget.1  = 'TEXT LE=10 TE=4 LB='text1' '
	Gadget.2  = 'TEXT LE=10 TE=14 LB='text2' '
	Gadget.3  = 'TEXT LE=10 TE=24 LB='text3' '
	Gadget.4  = 'TEXT LE=10 TE=34 LB='text4' '
	Gadget.5  = 'TEXT LE=10 TE=44 LB='text5' '
	Gadget.6 = 'END'
	NewComplexRequest  '"Instructions For Effect #06"' Gadget 370 56

return




PickCircle:
	KillBrush
	Menu ToolBox
	RequestNotify "Draw Circle Where Image Will Show Through!"
	DrawTool Oval
	HidePanel
	Undo On
	WaitFor SELECTDOWN
	parse var result X1 Y1
	WaitFor SELECTUP
	parse var result X2 Y2
	Undo
	ShowPanel
	Undo Off
	X1 = strip(X1)
	Y1 = strip(Y1)
	X2 = strip(X2)-X1
	Y2 = strip(Y2)-Y1
	RequestResponse "Is The Circle You Selected Correct?"
	if rc ~= 0 then call PickCircle()

	WindowType = X1" "Y1" "X2" "Y2

return


GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetA:
 if IAType = 0 then do
	call Switcher(TOSW)
	PicAName = GetFile("Select Flyer Clip For ImageA!  ",DriveName)
	Name = GetFileName(PicAName)
	if Name = "" then do
		Address FLY_1 OK_TEXT " OK "
		Title = "You Must Enter A Valid Clip Name To Use!"
		Address FLY_1 FYINT Title
		Address FLY_1 Quit
		call Switcher(TOWB)
		exit
		end
	Address FLY_1 SetFileName PicAName
	Address FLY_1 GetClipLength PicAName
	End = result
	Start = 0
	Address FLY_1 Program "5"
	Address FLY_1 StartNum Start
	Address FLY_1 EndNum End
	Address FLY_1 CurrentNum "0"
	Address FLY_1 GetTimeNT "Select A Range Of Frames To Process!"
	Start = word(result,1)*2
	End = word(result,2)*2
	Start  = Start + 1
	End = End +2
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	call Switcher(TOWB)
	address command "C:Wait 1"
	ScreenToFront
	end
   if IAType = 1 then do
	RequestFile '"Select Flyer Still For ImageA!"' DriveName ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 2 then do
	RequestFile '"Select FileName For ImageA!"' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 3 then do
	RequestFile '"Select BaseName For ImageA! "' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
return


OpenFlyStuff:
	FlyOn = 1
	address command "run VFXIFX:FLY" 
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	DriveName = FindDrive()
return


FindDrive:
	address command "C:Info >RAM:DriveList"
	call open TempFile,"RAM:DriveList",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			FlyVolume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:DriveList"
return FlyVolume



LoadA:
	if IAType = 0 then do
		LoadBuffer PicAName Force Start
		end
	if IAType = 1 then do
		LoadBuffer PicAName Force 1
		end
	if IAType = 2 then do
		LoadBuffer PicAName Force
		end
	if IAType = 3 then do
		LoadBuffer PicAName""right(Start,3,'0') Force
		end
return



