/*
                                 Visual FX
                                    For
                                 Image FX
                               SetUp Script
                           Written By J.L. White

                         (C)1997 Merlin's Software

*/

parse arg Num Frames
options results
address "IMAGEFX.1"
ReDraw On

	RequestResponse "Do You Need Instructions?"
	if rc = 0 then do
		call Docs()
		end	

if exists("libs:flyer.library") then do
	if (POS('PROJECT_REXX_PORT',SHOW('Ports')) =0) then do
		RequestNotify 'Flyer Must Be Running First!'
		exit
		end
	call OpenFlyStuff()


	Gadget.1 = 'D/110/22/120/ImageA Type/4/FLYER CLIP/FLYER STILL/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1
   		end

	call GetA()
end
else do
	Gadget.1 = 'D/110/22/120/ImageA Type/2/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1+2
   		end

	call GetA()
end

if FlyOn = 1 then
	call CloseStuff()


	Gadget.1 = ' Select Direction! '
	Gadget.2 = ' Horizontal '
	Gadget.3 = ' Vertical '
	ListRequest 3 Gadget
	DirectionType = "Horiz"
	if result = 2 then DirectionType = "Horiz"
	if result = 3 then DirectionType = "Vert"

	Gadget.1 = ' Select Speed Of Effect! '
	Gadget.2 = ' Slow '
	Gadget.3 = ' Medium '
	Gadget.4 = ' Fast '
	ListRequest 4 Gadget
	SANum = 16
	SBNum = 24
	if result = 2 then do
		SANum = 31
		SBNum = 12
		end
	if result = 3 then do
		SANum = 16
		SBNum = 24
		end
	if result = 4 then do
		SANum = 11
		SBNum = 36
		end

	RequestSlider '"Enter Total Amount Of Distortion!"' 1 255 120
	TAmount = Result

	RequestSlider '"Enter Total Amount Of Waves!"' 1 100 5
	Waves = Result

	CropAnswer = "None"
	RequestResponse "Does Image Need To Be Cropped?"
	if rc = 0 then do
		call LoadA()
		call CropPic()
		end	

call open TempFile,"VFXIFX:TempDrawer/"strip(Num),W
call writeln TempFile,PicAName
call writeln TempFile,Start
call writeln TempFile,End
call writeln TempFile,IAType
call writeln TempFile,DirectionType
call writeln TempFile,Waves
call writeln TempFile,TAmount
call writeln TempFile,SANum
call writeln TempFile,SBNum
call writeln TempFile,CropAnswer
call close TempFile
exit



CropPic:
	Learn "RAM:VFX" NoHeader Quiet Force
	Crop
	Learn Stop Quiet Force

	call open TempFile,"RAM:VFX.ifx",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line StartLine" "RestOfLine
		if StartLine = "Crop" then CropAnswer = line
		end
	call close TempFile
	address command "Delete >NIL: Ram:VFX.ifx"

return

GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetA:
 if IAType = 0 then do
	call Switcher(TOSW)
	PicAName = GetFile("Select Flyer Clip For ImageA!  ",DriveName)
	Name = GetFileName(PicAName)
	if Name = "" then do
		Address FLY_1 OK_TEXT " OK "
		Title = "You Must Enter A Valid Clip Name To Use!"
		Address FLY_1 FYINT Title
		Address FLY_1 Quit
		call Switcher(TOWB)
		exit
		end
	Address FLY_1 SetFileName PicAName
	Address FLY_1 GetClipLength PicAName
	End = result
	Start = 0
	Address FLY_1 Program "5"
	Address FLY_1 StartNum Start
	Address FLY_1 EndNum End
	Address FLY_1 CurrentNum "0"
	Address FLY_1 GetTimeNT "Select A Range Of Frames To Process!"
	Start = word(result,1)*2
	End = word(result,2)*2
	Start  = Start + 1
	End = End +2
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	call Switcher(TOWB)
	address command "C:Wait 1"
	ScreenToFront
	end
   if IAType = 1 then do
	RequestFile '"Select Flyer Still For ImageA!"' DriveName ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 2 then do
	RequestFile '"Select FileName For ImageA!"' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 3 then do
	RequestFile '"Select BaseName For ImageA! "' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
return


OpenFlyStuff:
	FlyOn = 1
	address command "run VFXIFX:FLY" 
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	DriveName = FindDrive()
return


FindDrive:
	address command "C:Info >RAM:DriveList"
	call open TempFile,"RAM:DriveList",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			FlyVolume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:DriveList"
return FlyVolume



LoadA:
	if IAType = 0 then do
		LoadBuffer PicAName Force Start
		end
	if IAType = 1 then do
		LoadBuffer PicAName Force 1
		end
	if IAType = 2 then do
		LoadBuffer PicAName Force
		end
	if IAType = 3 then do
		LoadBuffer PicAName""right(Start,3,'0') Force
		end
return



Docs:

	text1 = '"This effect takes an image and uses the Dream Hook to"'
	text2 = '"wiggle and shake the screen like that seen on TV in the"'
	text3 = '"Dream sequence effect. It eases in & out of the effect"'
	text4 = '"slowly then builds to a user defined Total Amount. You"'
	text5 = '"also have option to select speed and number of waves."'
	text6 = '" "'

	text7 = '"The Crop Image option is there for Flyer Users. It may"'
	text8 = '"have garbage on the edges that is not seen because of"'
	text9 = '"overscan, but when the image edges are wrapped around,"'
	text10 = '"you can see them. This allows you to crop the image"'
	text11 = '"first, then scale it back to the correct size."'

	Gadget.1  = 'TEXT LE=10 TE=4 LB='text1' '
	Gadget.2  = 'TEXT LE=10 TE=14 LB='text2' '
	Gadget.3  = 'TEXT LE=10 TE=24 LB='text3' '
	Gadget.4  = 'TEXT LE=10 TE=34 LB='text4' '
	Gadget.5  = 'TEXT LE=10 TE=44 LB='text5' '
	Gadget.6  = 'TEXT LE=10 TE=54 LB='text6' '
	Gadget.7  = 'TEXT LE=10 TE=64 LB='text7' '
	Gadget.8  = 'TEXT LE=10 TE=74 LB='text8' '
	Gadget.9  = 'TEXT LE=10 TE=84 LB='text9' '
	Gadget.10  = 'TEXT LE=10 TE=94 LB='text10' '
	Gadget.11  = 'TEXT LE=10 TE=104 LB='text11' '
	Gadget.12 = 'END'
	NewComplexRequest  '"Instructions For Effect #14"' Gadget 420 116

return


