/*
                                 Visual FX
                                    For
                                 Image FX
                               SetUp Script
                           Written By J.L. White

                         (C)1997 Merlin's Software

*/

parse arg Num Frames
options results
address "IMAGEFX.1"
Quotes = '22'X
	ReDraw On
	RequestResponse "Do You Need Instructions?"
	if rc = 0 then do
		call Docs()
		end	
if exists("libs:flyer.library") then do
	if (POS('PROJECT_REXX_PORT',SHOW('Ports')) =0) then do
		RequestNotify 'Flyer Must Be Running First!'
		exit
		end
	call OpenFlyStuff()


	Gadget.1 = 'D/135/22/120/Main Image Type/4/FLYER CLIP/FLYER STILL/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 280 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1
   		end

	call GetA()


	Gadget.1 = 'D/110/22/120/Border Type/5/COLOR/FLYER CLIP/FLYER STILL/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IBType = RESULT.1 -1
		if IBType = -1 then IBType = 4
   		end
	call GetB()
end
else do
	Gadget.1 = 'D/135/22/120/Main Image Type/2/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 280 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1+2
   		end

	call GetA()

	Gadget.1 = 'D/110/22/120/Border Type/3/COLOR/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IBType = RESULT.1+1
		if IBType = 1 then IBType = 4
   		end

	call GetB()
end

	KillBrush
	i = Start

	ReDraw On
	LoadBuffer "VFXIFX:Images/Pics/BGFrames.Pic" Force
	RequestNotify "Look At Examples For FileName Then Click "Quotes"Okay"Quotes""

	RequestFile '"Select File To Use For BG Overlay!" "VFXIFX:Images/BGFrames" ""'
	BGName = result


if FlyOn = 1 then
	call CloseStuff()

call open TempFile,"VFXIFX:TempDrawer/"strip(Num),W
call writeln TempFile,PicAName
call writeln TempFile,Start
call writeln TempFile,End
call writeln TempFile,IAType
call writeln TempFile,PicBName
call writeln TempFile,StartB
call writeln TempFile,EndB
call writeln TempFile,IBType
call writeln TempFile,BGName
call close TempFile
exit



Docs:
	text1 = '"This effect uses a special template thats made"'
	text2 = '"out of an image that uses both Blue & Green. It"'
	text3 = '"uses the Cinematte Hook to replace both colors"'
	text4 = '"with 2 other images. The Green is used for the"'
	text5 = '"border and is replaced first. The Blue part is"'
	text6 = '"used to place the Main image on the screen."'
	text7 = '" "'
	text8 = '"Note, that if your first image has blue in it,"'
	text9 = '"that will also be replaced on the second pass."'
	text10 = '"This may or may not give the results you want."'
	text11 = '"For example, if you replace the Green with White,"'
	text12 = '"then all happens as expected. However if you were"'
	text13 = '"to replace it with Purple, then on the next pass"'
	text14 = '"the blue would turn the purple to a transparent"'
	text15 = '"red. Experiment to see what you like best."'

	Gadget.1  = 'TEXT LE=10 TE=4 LB='text1' '
	Gadget.2  = 'TEXT LE=10 TE=14 LB='text2' '
	Gadget.3  = 'TEXT LE=10 TE=24 LB='text3' '
	Gadget.4  = 'TEXT LE=10 TE=34 LB='text4' '
	Gadget.5  = 'TEXT LE=10 TE=44 LB='text5' '
	Gadget.6  = 'TEXT LE=10 TE=54 LB='text6' '
	Gadget.7  = 'TEXT LE=10 TE=64 LB='text7' '
	Gadget.8  = 'TEXT LE=10 TE=74 LB='text8' '
	Gadget.9  = 'TEXT LE=10 TE=84 LB='text9' '
	Gadget.10  = 'TEXT LE=10 TE=94 LB='text10' '
	Gadget.11  = 'TEXT LE=10 TE=104 LB='text11' '
	Gadget.12  = 'TEXT LE=10 TE=114 LB='text12' '
	Gadget.13  = 'TEXT LE=10 TE=124 LB='text13' '
	Gadget.14  = 'TEXT LE=10 TE=134 LB='text14' '
	Gadget.15  = 'TEXT LE=10 TE=144 LB='text15' '
	Gadget.16= 'END'
	NewComplexRequest  '"Instructions For Effect #17"' Gadget 366 156
return


GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetA:
 if IAType = 0 then do
	call Switcher(TOSW)
	PicAName = GetFile("Select Flyer Clip For Main Image!  ",DriveName)
	Name = GetFileName(PicAName)
	if Name = "" then do
		Address FLY_1 OK_TEXT " OK "
		Title = "You Must Enter A Valid Clip Name To Use!"
		Address FLY_1 FYINT Title
		Address FLY_1 Quit
		call Switcher(TOWB)
		exit
		end
	Address FLY_1 SetFileName PicAName
	Address FLY_1 GetClipLength PicAName
	End = result
	Start = 0
	Address FLY_1 Program "5"
	Address FLY_1 StartNum Start
	Address FLY_1 EndNum End
	Address FLY_1 CurrentNum "0"
	Address FLY_1 GetTimeNT "Select A Range Of Frames To Process!"
	Start = word(result,1)*2
	End = word(result,2)*2
	Start  = Start + 1
	End = End +2
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	call Switcher(TOWB)
	address command "C:Wait 1"
	ScreenToFront
	end
   if IAType = 1 then do
	RequestFile '"Select Flyer Still For Main Image!"' DriveName ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 2 then do
	RequestFile '"Select FileName For Main Image!"' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 3 then do
	RequestFile '"Select BaseName For Main Image! "' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
	DriveName = GetPathName(PicAName)

return


GetB:
 if IBType = 0 then do
	call Switcher(TOSW)
	PicBName = GetFile("Select Flyer Clip For Border Image!  ",DriveName)
	Name = GetFileName(PicBName)
	if Name = "" then do
		Address FLY_1 OK_TEXT " OK "
		Title = "You Must Enter A Valid Clip Name To Use!"
		Address FLY_1 FYINT Title
		Address FLY_1 Quit
		call Switcher(TOWB)
		exit
		end
	Address FLY_1 SetFileName PicBName
	Address FLY_1 GetClipLength PicBName
	EndB = result
	StartB = 0
	Address FLY_1 Program "5"
	Address FLY_1 StartNum StartB
	Address FLY_1 EndNum EndB
	Address FLY_1 CurrentNum "-1"
	Address FLY_1 GetTimeNT "Select Frame To Start With For Border Image!"
	StartB = word(result,1)*2
	EndB = word(result,2)*2
	StartB  = StartB + 1
	EndB = EndB +2
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	call Switcher(TOWB)
	address command "C:Wait 1"
	ScreenToFront
	end
   if IBType = 1 then do
	RequestFile '"Select Flyer Still For Border Image!"' DriveName ' '
	PicBName = result
	Name = GetFileName(PicBName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	EndB = Frames
	StartB = 1
	end
   if IBType = 2 then do
	RequestFile '"Select FileName For Border Image!"' 'SYS:' ' '
	PicBName = result
	Name = GetFileName(PicBName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	EndB = Frames
	StartB = 1
	end
   if IBType = 3 then do
	RequestFile '"Select BaseName For Border Image! "' 'SYS:' ' '
	PicBName = result
	Name = GetFileName(PicBName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	EndB = Frames
	StartB = 1
	end

   if IBType = 4 then do
	ActiveColor 1
	RequestNotify "Click On Color To Use For Border Then Click "Quotes"Okay"Quotes""
	ActiveColor
	PicBName = result
	ActiveColor 1
	EndB = Frames
	StartB = 1
	end
return


CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
return


OpenFlyStuff:
	FlyOn = 1
	address command "run VFXIFX:FLY" 
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	DriveName = FindDrive()
return


FindDrive:
	address command "C:Info >RAM:DriveList"
	call open TempFile,"RAM:DriveList",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			FlyVolume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:DriveList"
return FlyVolume

GetPathName: procedure  
   parse ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return left(CompleteName,c)



