/*
                                 Visual FX
                                    For
                                 Image FX
                               SetUp Script
                           Written By J.L. White

                         (C)1997 Merlin's Software

*/
parse arg Num Frames
options results
address "IMAGEFX.1"
	RequestResponse "Do You Need Instructions?"
	if rc = 0 then do
		call Docs()
		end	


if exists("libs:flyer.library") then do
	if (POS('PROJECT_REXX_PORT',SHOW('Ports')) =0) then do
		RequestNotify 'Flyer Must Be Running First!'
		exit
		end
	call OpenFlyStuff()


	Gadget.1 = 'D/110/22/120/ImageA Type/4/FLYER CLIP/FLYER STILL/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1
   		end

	call GetA()
end
else do
	Gadget.1 = 'D/110/22/120/ImageA Type/2/FRAME/SEQUENCE'
	ComplexRequest  '"Visual FX  SetUp Options"' 1 Gadget 250 60
	if rc ~= 0 then do
		call CloseStuff()
		exit 0
		end
	else do
		IAType = RESULT.1+2
   		end

	call GetA()
end

if FlyOn = 1 then
	call CloseStuff()

	Gadget.1 = '  Select Direction Of Glint!  '
	Gadget.2 = '  Top Left To Bottom Right  '
	Gadget.3 = '  Top Right To Bottom Left  '
	Gadget.4 = '  Bottom Left To Top Right  '
	Gadget.5 = '  Bottom Right To Top Left  '
	ListRequest 5 Gadget
	DirectionType = 0
	if result = 2 then DirectionType = 0
	if result = 3 then DirectionType = 1
	if result = 4 then DirectionType = 2
	if result = 5 then DirectionType = 3


	RequestSlider '"Enter Thickness of Glint!"' 1 100 10
	ThickNum = Result

	RequestSlider '"Enter Brightness of Glint!"' 1 255 100
	BrightNum = Result

	RequestSlider '"Enter Opacity Of Glint!"' 1 100 50
	BlendNum = Result

	RequestSlider '"Enter Amount To Feather Edges!"' 1 50 45
	FeatherNum = Result


call open TempFile,"VFXIFX:TempDrawer/"strip(Num),W
call writeln TempFile,PicAName
call writeln TempFile,Start
call writeln TempFile,End
call writeln TempFile,IAType
call writeln TempFile,ThickNum
call writeln TempFile,BrightNum
call writeln TempFile,BlendNum
call writeln TempFile,FeatherNum
call writeln TempFile,DirectionType
call close TempFile
exit


GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetA:
 if IAType = 0 then do
	call Switcher(TOSW)
	PicAName = GetFile("Select Flyer Clip For ImageA!  ",DriveName)
	Name = GetFileName(PicAName)
	if Name = "" then do
		Address FLY_1 OK_TEXT " OK "
		Title = "You Must Enter A Valid Clip Name To Use!"
		Address FLY_1 FYINT Title
		Address FLY_1 Quit
		call Switcher(TOWB)
		exit
		end
	Address FLY_1 SetFileName PicAName
	Address FLY_1 GetClipLength PicAName
	End = result
	Start = 0
	Address FLY_1 Program "5"
	Address FLY_1 StartNum Start
	Address FLY_1 EndNum End
	Address FLY_1 CurrentNum "0"
	Address FLY_1 GetTimeNT "Select A Range Of Frames To Process!"
	Start = word(result,1)*2
	End = word(result,2)*2
	Start  = Start + 1
	End = End +2
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	call Switcher(TOWB)
	address command "C:Wait 1"
	ScreenToFront
	end
   if IAType = 1 then do
	RequestFile '"Select Flyer Still For ImageA!"' DriveName ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 2 then do
	RequestFile '"Select FileName For ImageA!"' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
   if IAType = 3 then do
	RequestFile '"Select BaseName For ImageA! "' 'SYS:' ' '
	PicAName = result
	Name = GetFileName(PicAName)
	if Name = "" then do
		Title = "You Must Enter A Valid Name To Use!"
		RequestNotify Title
		if FlyOn = 1 then Address FLY_1 Quit
		exit
		end
	RequestNumber '"Enter Number Of Frames To Process!"' Frames
	End = result
	Start = 1
	end
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
return


OpenFlyStuff:
	FlyOn = 1
	address command "run VFXIFX:FLY" 
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
	DriveName = FindDrive()
return


FindDrive:
	address command "C:Info >RAM:DriveList"
	call open TempFile,"RAM:DriveList",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			FlyVolume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:DriveList"
return FlyVolume



Docs:

	text1 = '"This effect takes an image and adds a glint of light"'
	text2 = '"scrolling across the face of the image. You can tell"'
	text3 = '"it what direction to go, what thickness, how bright,"'
	text4 = '"and what opacity to use. Select the defaults to see"'
	text5 = '"what we like best, then experiment on your own."'

	Gadget.1  = 'TEXT LE=10 TE=4 LB='text1' '
	Gadget.2  = 'TEXT LE=10 TE=14 LB='text2' '
	Gadget.3  = 'TEXT LE=10 TE=24 LB='text3' '
	Gadget.4  = 'TEXT LE=10 TE=34 LB='text4' '
	Gadget.5  = 'TEXT LE=10 TE=44 LB='text5' '
	Gadget.6 = 'END'
	NewComplexRequest  '"Instructions For Effect #18"' Gadget 380 56

return
